; the obnoxious doorbell
; $Id: doorbell.asm,v 1.5 2007/07/06 11:53:49 az Exp $
	
processor p12f509
include "p12f509.inc"

        __CONFIG        _MCLRE_ON & _CP_OFF & _WDT_OFF & _XT_OSC

SWPIN	equ	1		; gp1 is input,
SPKPIN	equ	2		; gp2 is output (and others, too: ignore 'm
				; as i was too lazy to tie them to gnd)
	
	cblock 0x7
pin 
freq 
duratn
f_copy
temp 
index
	endc

	org 0
	movwf OSCCAL
	movlw 0xff & 1<<SWPIN  ; switch input, rest output
	tris 6
	clrf GPIO	; mclr reset does NOT change io pins!
			; need to clear them so that
			; we don't drain the battery when sleeping

	movlw 0xff&~(1<<NOT_GPWU)&~(1<<T0CS)
	option
	;enable wakeup on pin, works on gp0,1,3
	;disable ext timer source, to open up gp2 for output!

	btfss STATUS,GPWUF	; woken up? then make noise!
	goto goodnight 

        clrf temp                  ; Clear LSB of duratn counter.
        clrf index                 ; Clear the note counter.
start_loop   movf index,w               ; Look up note in table.
             call notes                 
             movwf freq                 ; Store note in freq.
             movf index,w               ; Look up length in table.
             call duration              
             movwf duratn               ; Store in duratn.
             call sound
             incf index,f               ; Advance to next note
             movlw TSIZE	; index==table size?
		subwf index,w
             btfss STATUS,C
             goto start_loop

goodnight:		
	movfw GPIO		; read to clear pin status
	sleep

; this makes the "music": pin gets toggled as often as required
; freq is delay value for this frequency, undamaged on return
; 0: silent, f=1e6/(26*duratn). lowest tone: 150.8Hz
; duratn is 1..255,0, zeroed on return, in multiples of 3.328ms


sound   clrf temp		; full 256c for the duration, please!
	movlw 1<<SPKPIN
	movwf pin                  ; Put the mask into pin.
	xorwf GPIO,f
	movf freq,w                ; Use copy so freq value is saved.
        movwf f_copy
        btfsc STATUS,Z             ; If freq is 0, clear pin to
	clrf pin                   ; produce a silent delay.
Sound_loop   MOVF pin,w                 ; 1 load io mask
             decfSZ f_copy,f	;  2 do nothing if freq delay not expired
             CLRW               ;  3 by xoring with zero
             XORWF GPIO,f       ;  4 toggle output or not
             MOVF f_copy,w      ;  5 load freqdelay
             BTFSC STATUS,Z     ;  7 zero?
             MOVF freq,w        ;  (7 if zero) reload if zero
             MOVWF f_copy	;  8 plop it back
             INCF temp,f        ;  9 inc lsb duration
             BTFSC STATUS,Z     ;  11 overflow? 
             decFSZ duratn,f    ;  (11 if overflow) dec msb duration
             GOTO Sound_loop	;  13
	bcf GPIO,SPKPIN		; no audio at end
             RETLW 0h                   


#include "tune.inc"
	
 end
